#include"inout.h"
#include<stdlib.h> // Pour exit(int)
#include<string.h> // pour strlen...
#include <time.h> // pour time

#define BOOL int
#define TRUE 1
#define FALSE 0

typedef enum {PIQUE=0, COEUR, CARREAU, TREFLE} couleur;
typedef enum {VALET=11, DAME, ROI} valeur;
typedef struct lacarte {
  valeur val; // 11=valet, 12=dame, 13=roi, >13 interdit
  couleur col;
} *carte ;

// On s'autorise ces variables globales NON MODIFIABLES
char* nomCoul[] = {"pique","coeur","carreau","trefle"};
char* nomCoulCourt[]= {"♠", "♥", "♦","♣"};

// Pareil, non modifiable. Détail: la première case est non utilisée,
// la case de l'as est donc la numéro 1. Toutefois dans le pocker il
// faut faire comme si il vallait 14 (roi+1): par exemple une paire
// d'as gagne sur une paire de rois.
char* nomVal[] = {"dummy","as","2","3","4","5","6","7","8","9","10","valet","dame","roi"};
char* nomValCourt[] = {"dummy","1","2","3","4","5","6","7","8","9","10","V","D","R"}; 

void printCarteBete(carte c){
  printf("%d de %d",c -> val , c -> col);
}



void printCarte(carte c){
  printf("%s de %s",nomVal[c -> val],nomCoul[c -> col]);
}

void printCourt(carte c){
  printf("%s%s",nomValCourt[c -> val],nomCoulCourt[c -> col]);
}


void printMain(carte t[]){
  int i;
  for(i=0;i< 5 ; i ++){
    printCourt(t[i]);
    printf(" ");
  }
}

void printMainln(carte t[]){
  printMain(t);
  printf("\n");
}


BOOL appartientCarte(carte c,carte t[],int nb){
 return FALSE;
}

// On suppose a<b, retourne un nombre aléatoire dans l'intervale [a,b[
// (donc b ne peut pas être tiré, mais a oui).
int rand_a_b(int a,int b){
  return rand()%(b-a) + a;
}

// Pas très satisfaisant en général car si on approche d'un paquet
// vide le tirage peut mettre très longtemps avant de trouver les
// dernière cartes. Mais en l'absence de liste chaînées il est très
// rébarbatif de faire un tableau et d'enlever des cases (décalage des
// cases restantes...).
void rempliAleatoirement(carte dejavues[],int nbdejavues, carte m[],int nbAremplir){
  int stop = nbdejavues + nbAremplir;
  if (stop > 52) { printf("pas assez de cartes\n"); exit(1); }
  int i = 0; // indice dans m;
  int cpt = nbdejavues;
  while(cpt<stop){
    m[i] = (carte) malloc(sizeof(struct lacarte));
    (*(m[i])).col = rand_a_b(PIQUE,TREFLE+1);
    m[i] -> val = rand_a_b(1,ROI+1);
    if(! appartientCarte(m[i],dejavues,cpt)){
      dejavues[cpt]=m[i];
      cpt=cpt+1; // indice dans dejavue
      i = i + 1; // indices dans m
    } else {
      free(m[i]);
      //printf("collision dans le tirage, on recommence\n");
    }
  }
}


int main() {
  carte m1[5];
  carte m2[5];
  carte dejavues [10];
  srand(time(NULL)); // initialisation de rand
  rempliAleatoirement(dejavues,0,m1,5);
  rempliAleatoirement(dejavues,5,m2,5);
  printMainln(m1);
  printMainln(m2);
}
